*! version 2.0.0 July 23, 2006 @ 22:20:29
*! executes a characteristic as a command (with some twists)
program define dochar , rclass
version 9
	local myname "dochar"
	/* needs - Would be nice to allow if statements */
	/* 2.0.0 - Uses semicolons rather than separate characteristics to run multiple commands */
	/* 1.0.0 - An initial attempt to bury code in charactaristics */
	
	syntax anything, [self(str) loud TEMPnames(str) slow]

	capture local doThis : char `anything'
	if _rc {
		display as error "`myname': could not use " as input `"`anything'"' as error " as varname[char] format!"
		error _rc
		}

	if `"`doThis'"'=="" {
		display as text  "Nothing to run for `anything'"
		return local havechar "no"
		exit 0
		}

	tokenize "`anything'", parse("[]")
	if `"`1'"'=="_dta" {
		local xvar "_dta"
		}
	else {
		unab xvar: `1', min(1) max(1) name(`myname': `1')
		}
	local char `"`3'"'

	
	/* pulling apart the extra options to allow temp variables to be passed in */
	/* if the `slow' option is chosen, these should be at the top of the dummy do file */
	if `"`tempnames'"'!="" {
		tokenize "`tempnames'", parse(": ")
		local cnt 1
		while "``cnt''"!="" {
			local next = `cnt' + 1
			local value = `cnt' + 2
			if ("``cnt''"==":") | ("``next''"!=":") | ("``value''"==":") {
				display as error "`myname': could not figure out the lclname:value list"
				display as error "`options'"
				exit 198
				}
			local ``cnt'' "``value''"
			local cnt = `cnt' + 3
			}
		local passTempnames "tempnames(`tempnames')"
		}
	
	if "`self'"=="" {
		local self "`xvar'"
		}

	/* for now, like can only be used alone (not buried in code) */
	local like: word 1 of `doThis'
	if lower("`like'")=="like" {
		local like : word count `1'
		if `like' > 2 {
			display as error "`myname': The usage for " as result "like" as error " when checking variables is " as result "like varname"
			exit 198
			}
		
		local likevar : word 2 of `doThis'
		/* need to remove the trailing semicolon */
		local likevar : subinstr local likevar ";" ""
		if "`loud'"!="" {
			display as text "doing it like " as result "`likevar'"
			}
		dochar `likevar'[`char'], self(`self') `loud' `passTempnames' `slow'
		local likeVarlist "`r(likeVarlist)' `likevar'"
		}
	else {
		/* check for -in- char --- awful hack */
		if `"`like'"'=="in" {
			/* if using an `in' clause, the first value in the lclname:value list is the new variable name */
			tokenize "`tempnames'", parse(": ")
			local gen `3'

			local doThis : subinstr local doThis "in" ""
			capture set2logic `self' `doThis'
			if _rc {
				capture _stata2logic, values(`doThis')
				if _rc {
					display as error "`myname': had trouble figuring out -in- clause for `self'[`char']" 
					exit 198
					}
				else {
					gen byte `gen' = inlist(`self',`r(theList)')
					}
				}
			else {
				gen byte `gen' = `r(logic)'
				}
			}
		else {
			/* this nice, clever solution won't work, because of the way that semicolons are evaluated... */
			/* #delimit ; */
			/* 		`doThis'; */
			/* #delimit cr */

			if "`slow'"!="" {
				tempname localdo
				tempfile localdofile
				file open `localdo' using "`localdofile'", write text
				/* reparsing the temp names */
				if `"`tempnames'"'!="" {
					tokenize "`tempnames'", parse(": ")
					local cnt 1
					while "``cnt''"!="" {
						local next = `cnt' + 1
						local value = `cnt' + 2
						file write `localdo' `"local ``cnt'' "``value''""' _n
						local cnt = `cnt' + 3
						}
					}
				}

			if "`slow'"!="" {
				tokenize `"`macval(doThis)'"', parse(";")
				local cnt 1
				while `"``cnt''"'!="" {
					if `"``cnt''"'!=";" {
						file write `localdo' `"`macval(`cnt')'"' _n
						}
					local ++cnt
					}
				file close `localdo'
				if "`loud'"=="" {
					run `localdofile'
					}
				else {
					do `localdofile'
					}
				}
			else {
				tokenize `"`macval(doThis)'"', parse(";")
				local cnt 1
				while `"``cnt''"'!="" {
					if `"``cnt''"'!=";" {
						if "`loud'"!="" {
							display as text "Trying to execute " as result `"``cnt''"'
							}
						capture noisily ``cnt''
						local rc _rc
						if `rc' {
							display as error "`myname': Had trouble executing " as input `"``cnt''"'
							exit `rc'
							}
						}
					local ++cnt
					}
				}	/* end of slow split */
			} 	/* end of check for in */
		} /* end of check for like */
	return local havechar "yes"
	return local likeVarlist "`likeVarlist'"
end

program define like
	dochar `*'[$doCharChar], self($doVarVar) 
end

program define _stata2logic, rclass
	syntax, values(numlist)
	local foo : subinstr local values " " ",", all
	return local theList `foo'
end
